%% Arduino initial settings

mdlName=get_param; % Get model file name
% Get the state of the switch between Arduino and simulation mode
sim_mode=get_param([mdlName,'/FB inverter control/Manual Switch: UP: MATLAB Simulation DOWN: Arduino External Mode'],'MaskValues');
Deblock=str2num(get_param([mdlName,'/Slider Switch'],'Value'))

if isequal(sim_mode(2),{'V_1'}) 
   fs=200000;   % Fundamental simulation sample time 
else
   fs=2000;   % Fundamental Arduino sample time 
end;
% Control parameters
Ts=1/fs;
fc = 2000;  % Control loop frequency (Hz)
Tsc = 1/fc;  % Control loop sample time
fo = 100; % Order input sampling frequency
Tso = 1/fo; % Order input sampling time

Lev1_Ts=Ts;
Lev2_Ts=Tsc;
Lev3_Ts=Tso;

Lev1_tck=Lev1_Ts/Ts;
Lev2_tck=Lev2_Ts/Ts;
Lev3_tck=Lev3_Ts/Ts;

% SAM3X
MCLK = 84e6;

tblank=2e-6;
tminon=3*tblank;
Dmin=0; % tminon/Tsw;
Dmax=1; % 1-Dmin;
dDmax=0.5;

%% Tunable parameters
if isequal(sim_mode(2),{'V_1'}) 
else
    Deblock=0;
    Freq=50; % Fundamental frequency
    ma_ref=0.7;
    fsw = 2000;   % Switching frequency (Hz)
    Tsw = 1/fsw; % Switching cycle time
    Uac_ref=8.0;
    Ud_FF=0;
    PWM_mode=0; % Unipolar PWM
    Iac_ref=0.5;
    Ctrl_on=0;
end;

%% PWM modes
Carrier=1; % Center aligned triangular carrier
Amde=3; % Both phase A MOSFETs T1, T2 used
Bmde=3; % Both phase B MOSFETs T3, T4 used
Boot_charge=1; % Boot strap charging used. T2 and T4 turned on for 2ms at deblock
% Gp=2; 

%% implement controller gains 
% alpha_c = ??; % closed-loop bandwidth
k_p = 0; % proprtional gain
k_ff = 0; % feed-forward gain

%% To workspace settings
max_points=1000;
dec_points=1;
Ts_ws = Tsc;
